/*
 * Copyright 2004 JTracker.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
package org.jtracker.jtcase.eng;

import java.util.Vector;
import java.util.HashMap;
import java.util.Map;
import org.jtracker.jtcode.framework.model.file.FileModel;
import org.jtracker.jtcode.framework.model.file.LineModel;

public class CaseAnalyser extends FileModel{
  final static String CASE_BPOINT_START = "/*<<<";
  final static String CASE_BPOINT_SET = "=";
  final static String TPID_SIGN_TPMODE_END = ">>>*/";
  final static int TPID_SIGN_TPMODE_LONG_MIN = 11;
  final static String SRC_PACKAGE = "package";
  final static String SRC_LINE_END = ";";
  final static String SRC_FILE_DIV = ".";
  Vector TpIDLst = new Vector();
  Vector dubIDLst = new Vector();
  Map idMap = new HashMap();
  String path="";
  String packageName ="";
  String className="";
  boolean hasPackage=false;
  public CaseAnalyser() {
  }
  public CaseAnalyser(String fileName){
    className=produceCLASSFromFile(fileName);
    TpIDLst = new Vector();
    processFile(fileName);
  }
  public Vector getIDfromSource(String fileName){
    className=produceCLASSFromFile(fileName);
    TpIDLst = new Vector();
    processFile(fileName);
    return TpIDLst;
  }
  public Vector getTpIDLst(){
    return TpIDLst;
  }
  public Vector getdubIDLst(){
    return dubIDLst;
  }
  public String getPackageName(){
    return packageName;
  }
  public String getClassName(){
    return className;
  }
  protected void processLine(String str,int line){
  TPIDModel idObj = new TPIDModel(str,line);
  String id = idObj.getTpID();
  String idStr = idObj.getTpIDItem();
  if(idStr!=null) {
	TpIDLst.add(idObj);
        if(idMap.containsKey(id)){dubIDLst.add(idObj);
           }else{idMap.put(id,new Integer(line));}
        }
  //look for package info
  if(!hasPackage){
    if(str.indexOf(SRC_PACKAGE)>=0){packageName = producePackageFromSrc(str);}
    }
  }
private String producePackageFromSrc(String str){
    String id = "";
    int idx_s = str.indexOf(SRC_PACKAGE);
    int idx_e = str.indexOf(SRC_LINE_END);
    id = str.substring(idx_s+SRC_PACKAGE.length(),idx_e);
    return id.trim();
}
private String produceCLASSFromFile(String str){
    String id = "";
    int idx_e = str.indexOf(SRC_FILE_DIV);
    id = str.substring(0,idx_e);
    return id.trim();
}
public static void main(String args[]){
TPIDAnalyser obj = new TPIDAnalyser(args[0],"");
Vector vLst = obj.getTpIDLst();
System.out.println("***************************************");
System.out.println("==============ID LIST==================");
for(int i=0;i<vLst.size();i++){
System.out.println(((TPIDModel)vLst.get(i)).getTpIDItem());
}
System.out.println("***************************************");
System.out.println("==============dubID LIST==================");
Vector vLst2 = obj.getdubIDLst();
for(int i=0;i<vLst2.size();i++){
System.out.println(((TPIDModel)vLst2.get(i)).getTpIDItem());
}
System.out.println("***************************************");
System.out.println("package:"+obj.getPackageName());
System.out.println("class:"+obj.getClassName());
}
}
