/*
 * Copyright 2004 JTracker.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jtracker.jtcase.eng;

import java.util.Vector;
import org.jtracker.jtcode.framework.model.file.FileModel;
import org.jtracker.jtcode.framework.model.file.LineModel;

public class CaseModel {
	public final static String CASE_SET = "=";
	public final static String CASE_LINE_SPACE_B = "   ";
	public final static String CASE_LINE_END = ";";
	public final static String CASE_INFO = "caseInfo";
	public final static String CASE_INFO_TITLE = "title";
	public final static String CASE_INFO_PATH = "path";
	public final static String CASE_INFO_PACKAGE = "package";
	public final static String CASE_INFO_SOURCE = "source";
	public final static String CASE_INFO_CLASS = "class";
	public final static String CASE_MODULE_START = "{";
	public final static String CASE_MODULE_END = "}";
	public final static String CASE_PARAM_START = "(";
	public final static String CASE_PARAM_END = ")";
	public final static String CASE_MODULE_PARAM_DIV = ",";
	public final static String CASE_BPOINT = "BPoint";
	public final static String CASE_BPOINT_TPID = "TP";
	public final static String CASE_BPOINT_LINE = "line";
	public final static String CASE_FUNC_TITLE = "title";
	Vector TpIDLst = new Vector();
	String title="";
	String path="";
	String packageName ="";
	String className="";
	String srcFile = "";	
	
  public CaseModel() {
  }
  
 public static void main(String args[]){
}
	/**
	 * @return
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * @return
	 */
	public String getPackageName() {
		return packageName;
	}

	/**
	 * @return
	 */
	public String getPath() {
		return path;
	}

	/**
	 * @return
	 */
	public String getSrcFile() {
		return srcFile;
	}

	/**
	 * @return
	 */
	public Vector getTpIDLst() {
		return TpIDLst;
	}

	/**
	 * @param string
	 */
	public void setClassName(String string) {
		className = string;
	}

	/**
	 * @param string
	 */
	public void setPackageName(String string) {
		packageName = string;
	}

	/**
	 * @param string
	 */
	public void setPath(String string) {
		path = string;
	}

	/**
	 * @param string
	 */
	public void setSrcFile(String string) {
		srcFile = string;
	}

	/**
	 * @param vector
	 */
	public void setTpIDLst(Vector vector) {
		TpIDLst = vector;
	}
    public String produceCase(){
    	String str="";
    	str+= CASE_INFO + CASE_MODULE_START+"\n";
    	str+= CASE_LINE_SPACE_B + CASE_INFO_TITLE + CASE_SET +title+ CASE_LINE_END+"\n";
    	str+= CASE_LINE_SPACE_B + CASE_INFO_PATH + CASE_SET +path+ CASE_LINE_END+"\n";
		str+= CASE_LINE_SPACE_B + CASE_INFO_SOURCE + CASE_SET +srcFile+ CASE_LINE_END+"\n";
		str+= CASE_LINE_SPACE_B + CASE_INFO_PACKAGE + CASE_SET +packageName+ CASE_LINE_END+"\n";
		if(packageName.trim().equals("")){
			str+= CASE_LINE_SPACE_B + CASE_INFO_CLASS + CASE_SET +className+ CASE_LINE_END+"\n";
		}else{
			str+= CASE_LINE_SPACE_B + CASE_INFO_CLASS + CASE_SET +packageName+"."+className+ CASE_LINE_END+"\n";
		}
		str+= CASE_MODULE_END+"\n";
		str+=produceBpointByID(TpIDLst);
    	return str;
    }
    private String produceBpointByID(Vector lst){
    	String str="";
		for(int i=0;i<TpIDLst.size();i++){
			TPIDModel idModel = (TPIDModel)TpIDLst.get(i);
			str+=CASE_BPOINT+CASE_PARAM_START;
			str+=CASE_BPOINT_TPID + CASE_SET + idModel.getTpID();
			str+=CASE_PARAM_END+CASE_MODULE_START+"\n";
			str+=CASE_LINE_SPACE_B + CASE_FUNC_TITLE+CASE_PARAM_START+idModel.getTpID()+CASE_PARAM_END+ CASE_LINE_END+"\n";
			str+=CASE_MODULE_END+"\n";
		}  
		return str;	
    }
}
