/*
 * Copyright 2004 JTracker.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jtracker.jtcase.eng;

import java.util.Vector;
import org.jtracker.jtcode.framework.model.file.FileModel;
import org.jtracker.jtcode.framework.model.file.LineModel;

public class TPIDModel {
  final static String TPID_SIGN_COMMENTMODE_BEGIN="//";
  final static int TPID_SIGN_COMMENTMODE_LONG_MIN = 2;
  final static String TPID_SIGN_TPMODE_BEGIN = "/*<<<";
  final static String TPID_SIGN_TPMODE_SET = "=";
  final static String TPID_SIGN_TPMODE_END = ">>>*/";
  final static int TPID_SIGN_TPMODE_LONG_MIN = 11;
  final static String TPID_ITEM_DIV = " ";
  public static  String idFilt = null;
  int line = -1;
  String TPID = "";
  public TPIDModel() {
  }
  public TPIDModel(String str,int line){
  processLine(str,line);
  }
  public TPIDModel(TPIDModel idModel){
  this.line = idModel.getLine();
  this.TPID = idModel.getTpID();
  }
  public String getTpIDItem(){
  if(TPID==null){return null;
    }else{
         return line+TPID_ITEM_DIV+TPID;}
  }
  public void setLine(int line){
  this.line = line;
  }
  public int getLine(){
  return line;
  }
  public void setTpID(String id){
  this.TPID = id;
  }
  public String getTpID(){
  return TPID;
  }

  protected void processLine(String str,int line){
  this.line = line;
  String id = null;
   if(str.indexOf(TPID_SIGN_COMMENTMODE_BEGIN)>=0&&str.length()>TPID_SIGN_COMMENTMODE_LONG_MIN){
     id=getTpID_CommentMode(str);
      }
   if(str.indexOf(TPID_SIGN_TPMODE_BEGIN)>=0&&str.length()>TPID_SIGN_TPMODE_LONG_MIN){
     id=getTpID_TPMode(str);
     }
   TPID = id;
  }
  public static String produceTPIDString(String str,int line){
  String id = null;
   if(str.indexOf(TPID_SIGN_COMMENTMODE_BEGIN)>=0&&str.length()>TPID_SIGN_COMMENTMODE_LONG_MIN){
     id=getTpID_CommentMode(str);
     return line+TPID_ITEM_DIV+id;
      }
   if(str.indexOf(TPID_SIGN_TPMODE_BEGIN)>=0&&str.length()>TPID_SIGN_TPMODE_LONG_MIN){
     id=getTpID_TPMode(str);
     return line+TPID_ITEM_DIV+id;
     }
   return null;
  }
  public static String getTpID_CommentMode(String str){
    String id = "";
    int idx_s = str.indexOf(TPID_SIGN_COMMENTMODE_BEGIN);
    int idx_e = str.length();

    id = str.substring(idx_s+TPID_SIGN_COMMENTMODE_BEGIN.length(),idx_e);
    return id.trim();
  }
  public static String getTpID_TPMode(String str){
    String id = "";
    int idx_s = str.indexOf(TPID_SIGN_TPMODE_SET);
    int idx_e = str.indexOf(TPID_SIGN_TPMODE_END);
    id = str.substring(idx_s+TPID_SIGN_TPMODE_SET.length(),idx_e);
    return id.trim();
  }
public static void main(String args[]){
}
}
