/*
 * Copyright 2004 JTracker.org
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jtracker.jtcase.ui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import org.jtracker.jtcase.eng.*;

public class JTcasePanel extends JPanel {
  JTextField txtSourceFile = new JTextField();
  JButton btnOpenSrcFile = new JButton();
  JButton btnAnalyseSrc = new JButton();
  JTextArea txtCaseInfo = new JTextArea();
  JButton btnProduceCase = new JButton();
  TPIDList lstTpID = new TPIDList();
  JLabel filter = new JLabel();
  JLabel jLabel1 = new JLabel();
  JFileChooser jFileChooserPath = new JFileChooser();
  JTextField txtCaseFile = new JTextField();
  JLabel jLabel3 = new JLabel();
  JButton btnCaseFile = new JButton();
  TPIDAnalyser idAnalyser = new TPIDAnalyser();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea txtSourceView = new JTextArea();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextArea txtCaseView = new JTextArea();
  JButton btnSave = new JButton();
  JTextField txtIDFilter = new JTextField();
  public JTcasePanel() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    filter.setText("IDFilt:");
    filter.setBounds(new Rectangle(30, 46, 49, 15));
    txtSourceFile.setText(AppProperty.getSourceFile());
    txtSourceFile.setBounds(new Rectangle(79, 17, 262, 19));
    this.setDebugGraphicsOptions(0);
    this.setLayout(null);
    btnOpenSrcFile.setBounds(new Rectangle(350, 12, 23, 25));
    btnOpenSrcFile.setText("...");
    btnAnalyseSrc.setBounds(new Rectangle(189, 42, 115, 25));
    btnAnalyseSrc.setText("analyse source");
    txtCaseInfo.setText("");
    txtCaseInfo.setBounds(new Rectangle(31, 514, 283, 70));
    btnProduceCase.setBounds(new Rectangle(27, 597, 107, 25));
    btnProduceCase.setText("Produce Case");
    lstTpID.setBounds(new Rectangle(31, 80, 283, 427));
    lstTpID.addMouseListener(new JTcasePanel_lstTpID_mouseAdapter(this));
    jLabel1.setText("Source:");
    jLabel1.setBounds(new Rectangle(32, 18, 43, 15));
    txtCaseFile.setText(AppProperty.getCaseFile());
    txtCaseFile.setBounds(new Rectangle(64, 633, 240, 21));
    jLabel3.setText("Output:");
    jLabel3.setBounds(new Rectangle(26, 634, 37, 16));
    btnCaseFile.addActionListener(new JTcasePanel_btnCaseFile_actionAdapter(this));
    btnCaseFile.setText("...");
    btnCaseFile.addActionListener(new JTcasePanel_btnCaseFile_actionAdapter(this));
    btnCaseFile.setBounds(new Rectangle(311, 632, 23, 25));
    jScrollPane1.setBounds(new Rectangle(320, 40, 651, 318));
    txtSourceView.setText("");
    jScrollPane2.setBounds(new Rectangle(320, 365, 651, 219));
    btnSave.setBounds(new Rectangle(161, 598, 114, 23));
    btnSave.setText("Save");
    btnSave.addActionListener(new JTcasePanel_btnSave_actionAdapter(this));
    txtIDFilter.setBounds(new Rectangle(78, 47, 62, 20));
    this.add(jLabel1, null);
    this.add(btnOpenSrcFile, null);
    this.add(filter, null);
    this.add(lstTpID, null);
    this.add(txtCaseInfo, null);
    this.add(btnProduceCase, null);
    this.add(jLabel3, null);
    this.add(txtCaseFile, null);
    this.add(btnCaseFile, null);
    this.add(jScrollPane1, null);
    this.add(jScrollPane2, null);
    this.add(txtSourceFile, null);
    this.add(btnAnalyseSrc, null);
    this.add(btnSave, null);
    this.add(txtIDFilter, null);
    jScrollPane2.getViewport().add(txtCaseView, null);
    jScrollPane1.getViewport().add(txtSourceView, null);
    btnAnalyseSrc.addActionListener(new JTcasePanel_btnAnalyseSrc_actionAdapter(this));
    btnProduceCase.addActionListener(new JTcasePanel_btnProduceCase_actionAdapter(this));
    btnOpenSrcFile.addActionListener(new JTcasePanel_btnOpenSrcFile_actionAdapter(this));
  }


  void btnAnalyseSrc_actionPerformed(ActionEvent e) {
    String srcFile = txtSourceFile.getText();
    idAnalyser = new TPIDAnalyser(srcFile,txtIDFilter.getText());
    Vector idLst = idAnalyser.getTpIDLst();
    lstTpID.removeAll();
    lstTpID.setListData(idLst);
    txtSourceView.removeAll();
    txtSourceView.append(idAnalyser.getSrcText());
    txtCaseInfo.setText("");
    txtCaseInfo.append("path:    "+idAnalyser.getPath()+"\n");;
    txtCaseInfo.append("source:  "+idAnalyser.getSrcFile()+"\n");
	txtCaseInfo.append("package: "+idAnalyser.getPackageName()+"\n");
	txtCaseInfo.append("class:   "+idAnalyser.getClassName()+"\n");
  }

  void btnProduceCase_actionPerformed(ActionEvent e) {
   if(idAnalyser==null){return;}
   CaseModel caseModel = new CaseModel();
   caseModel.setPath(idAnalyser.getPath());
   caseModel.setSrcFile(idAnalyser.getSrcFile());
   caseModel.setPackageName(idAnalyser.getPackageName());
   caseModel.setClassName(idAnalyser.getClassName());
   caseModel.setTpIDLst(lstTpID.getSelectData());
   txtCaseView.setText("");
   txtCaseView.append(caseModel.produceCase());
   txtCaseFile.setText(idAnalyser.getPath()+"\\"+idAnalyser.getClassName()+".tc");
  }





  void btnOpenSrcFile_actionPerformed(ActionEvent e) {

    //jFileChooserPath.setFileSelectionMode(jFileChooserPath.DIRECTORIES_ONLY);
    if(!txtSourceFile.getText().trim().equals("")) jFileChooserPath.setCurrentDirectory(new File(txtSourceFile.getText()));

    if(jFileChooserPath.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
      File choseFile = jFileChooserPath.getSelectedFile();
      //if(choseFile.isFile())
          txtSourceFile.setText(choseFile.getPath());
      }

  }



  void btnAdd_actionPerformed(ActionEvent e) {

  }

  void btnCaseFile_actionPerformed(ActionEvent e) {
    //jFileChooserPath.setFileSelectionMode(jFileChooserPath.DIRECTORIES_ONLY);
    if(!txtCaseFile.getText().trim().equals("")) jFileChooserPath.setCurrentDirectory(new File(txtCaseFile.getText()));

    if(jFileChooserPath.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
      File choseFile = jFileChooserPath.getSelectedFile();
      //if(choseFile.isFile())
          txtCaseFile.setText(choseFile.getPath());
      }

  }

  void btnSave_actionPerformed(ActionEvent e) {
   try{
   	FileWriter fWriter = new FileWriter(txtCaseFile.getText());
   	BufferedWriter bWriter = new BufferedWriter(fWriter);
   	fWriter.write(txtCaseView.getText());
   	fWriter.flush();
   	fWriter.close();
   }catch(Exception ex){ex.printStackTrace();}
  }

  void lstTpID_mouseClicked(MouseEvent e) {
  }

}

class JTcasePanel_btnAdd_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnAdd_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAdd_actionPerformed(e);
  }
}

class JTcasePanel_btnAnalyseSrc_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnAnalyseSrc_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAnalyseSrc_actionPerformed(e);
  }
}

class JTcasePanel_btnProduceCase_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnProduceCase_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnProduceCase_actionPerformed(e);
  }
}

class JTcasePanel_btnOpenSrcFile_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnOpenSrcFile_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOpenSrcFile_actionPerformed(e);
  }
}

class JTcasePanel_btnCaseFile_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnCaseFile_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCaseFile_actionPerformed(e);
  }
}

class JTcasePanel_btnSave_actionAdapter implements java.awt.event.ActionListener {
  JTcasePanel adaptee;

  JTcasePanel_btnSave_actionAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnSave_actionPerformed(e);
  }
}

class JTcasePanel_lstTpID_mouseAdapter extends java.awt.event.MouseAdapter {
  JTcasePanel adaptee;

  JTcasePanel_lstTpID_mouseAdapter(JTcasePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.lstTpID_mouseClicked(e);
  }
}


